﻿using HelloWorldIoTCS_2017.GpioControl;
using HelloWorldIoTCS_2017.ViewModels;
using System;
using System.Diagnostics;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace HelloWorldIoTCS_2017
{
    public sealed partial class MainPage : Page
    {
        private BlinkingViewModel blinkingViewModel = new BlinkingViewModel();
        private LedBlinking ledBlinking;

        public MainPage()
        {
            InitializeComponent();
        }

        private void ButtonInitializeGpio_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                ledBlinking = new LedBlinking(blinkingViewModel.GpioPinNumber, blinkingViewModel.MsShineDuration);
                blinkingViewModel.IsGpioPinAvailable = true;
            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex.Message);
            }
        }

        private void ButtonStartBlinking_Click(object sender, RoutedEventArgs e)
        {
            ledBlinking.Start();
            blinkingViewModel.IsBlinkingActive = ledBlinking.IsActive;
        }

        private void ButtonStopBlinking_Click(object sender, RoutedEventArgs e)
        {
            ledBlinking.Stop();
            blinkingViewModel.IsBlinkingActive = ledBlinking.IsActive;
        }
    }
}
