﻿#include "pch.h"
#include "MainPage.xaml.h"

using namespace HelloWorldIoTCpp;
using namespace Platform;

MainPage::MainPage()
{
	InitializeComponent();
}

void MainPage::OnNavigatedTo(NavigationEventArgs ^e)
{
	__super::OnNavigatedTo(e);

	BlinkLed(pinNumber, msShineDuration);
}

GpioPin ^MainPage::ConfigureGpioPin(int pinNumber)
{
	auto gpioController = GpioController::GetDefault();

	GpioPin ^pin = nullptr;

	if (gpioController != nullptr)
	{
		pin = gpioController->OpenPin(pinNumber);

		if (pin != nullptr)
		{
			pin->SetDriveMode(GpioPinDriveMode::Output);
		}
	}

	return pin;
}

void MainPage::BlinkLed(int ledPinNumber, int msShineDuration)
{
	GpioPin ^ledGpioPin = ConfigureGpioPin(ledPinNumber);

	if (ledGpioPin != nullptr)
	{
		ledGpioPin->Write(GpioPinValue::Low);

		Sleep(msShineDuration);		

		ledGpioPin->Write(GpioPinValue::High);
	}
}
