﻿using SenseHat.Helpers;
using System;

namespace AnomalyDetection.PredictiveClient
{
    public class PredictionScore
    {        
        public double Temperature { get; set; }
        public double Label { get; set; }
        public double Probability { get; set; }

        public bool IsNormal
        {
            get { return !Convert.ToBoolean(Label); }
        }

        public PredictionScore()
        {

        }

        public PredictionScore(PredictionResponse predictiveServiceResponse)
        {
            Check.IsNull(predictiveServiceResponse);

            var values = predictiveServiceResponse.Results.AnomalyDetectionResult.Value.Values;

            if (values.Length > 0)
            {
                Temperature = Convert.ToDouble(values[0, 0]);
                Label = Convert.ToDouble(values[0, 1]);
                Probability = Convert.ToDouble(values[0, 2]);
            }
        }

        public override string ToString()
        {
            return $"Temperature: {Temperature:F2}, label: {Label}, Probability: {Probability:F3}";
        }
    }
}
