﻿using CustomIoTSolution.NotificationClient.Models;
using Microsoft.WindowsAzure.Storage.Table;
using SenseHat.UWP.Sensors;
using System;

namespace CustomIoTSolution.NotificationClient.Helpers
{
    public static class EntityConverter
    {
        public static SensorReadings DynamicTableEntityToSensorReadings(DynamicTableEntity dynamicTableEntity)
        {
            SensorReadings sensorReadings = null;

            if (dynamicTableEntity != null)
            {
                sensorReadings = new SensorReadings()
                {
                    Temperature = Convert.ToSingle(dynamicTableEntity.Properties["temperature"].PropertyAsObject),
                    Humidity = Convert.ToSingle(dynamicTableEntity.Properties["humidity"].PropertyAsObject),
                    Pressure = Convert.ToSingle(dynamicTableEntity.Properties["pressure"].PropertyAsObject)
                };
            }

            return sensorReadings;
        }

        public static TemperatureAlertInfo DynamicTableEntityToTemperatureAlertInfo(DynamicTableEntity dynamicTableEntity)
        {
            TemperatureAlertInfo temperatureAlertInfo = null;

            if (dynamicTableEntity != null)
            {        
                temperatureAlertInfo = new TemperatureAlertInfo()
                {
                    DeviceId = dynamicTableEntity.PartitionKey,
                    Temperature = dynamicTableEntity.Properties["AlertTemperature"].DoubleValue.Value
                };
            }

            return temperatureAlertInfo;
        }
    }
}
